<script type="ts">
    import { layout } from "./svelte_stores/layout_store";
    import { hapi_servers } from "./svelte_stores/hapi_servers";
    import { global_zoom_detail_factor } from "./svelte_stores/zoom_range_store";

    import RangeWithNumberInput from "./form_components/RangeWithNumberInput.svelte";

    import {
        Label,
        Input,
        Button,
        ButtonGroup,
        Toggle,
        Helper,
    } from "flowbite-svelte";

    let new_hapi_server = "http://localhost/hapi";

    const check_and_add_hapi_server = function () {
        $hapi_servers.push({ value: new_hapi_server, name: new_hapi_server });
    };

    $: some_legends = $layout.subplots
        .map((s) => {
            return s.legend_visible;
        })
        .some((el) => {
            return el == true;
        });
</script>

<div class="flex flex-col gap-3">
    <!-- <h2>Dark/light mode</h2>
    <DarkMode /> -->

    <h2>Global margins:</h2>
    <Label
        >Left margin
        <RangeWithNumberInput
            min={0}
            max={500}
            step={1}
            bind:value={$layout.global_margins.left} />
    </Label>
    <Label
        >Right margin
        <RangeWithNumberInput
            min={0}
            max={500}
            step={1}
            bind:value={$layout.global_margins.right} />
    </Label>
    <Label
        >Top margin
        <RangeWithNumberInput
            min={0}
            max={500}
            step={1}
            bind:value={$layout.global_margins.top} />
    </Label>
    <Label
        >Bottom margin
        <RangeWithNumberInput
            min={0}
            max={500}
            step={1}
            bind:value={$layout.global_margins.bottom} />
    </Label>

    <h2>Detail</h2>
    <Label
        >Zoom detail factor:
        <Helper
            >The maximum number of points that will be loaded for a dataset is
            determined by the number of pixels in the graph (depends on display
            and browser window size), multiplied by this global factor and a
            plot-element specific factor.</Helper>
        <RangeWithNumberInput
            min={0.25}
            max={4}
            step={0.25}
            bind:value={$global_zoom_detail_factor} />
    </Label>

    <h2>Legends</h2>
    <Toggle
        checked={some_legends}
        on:click={(e) => {
            if (some_legends) {
                $layout.subplots.forEach((subplot, i_subplot) => {
                    $layout.subplots[i_subplot].legend_visible = false;
                });
            } else {
                $layout.subplots.forEach((subplot, i_subplot) => {
                    $layout.subplots[i_subplot].legend_visible = true;
                });
            }
        }}>
        Show/hide all legends.
    </Toggle>

    <h2>Temporarily add a HAPI server</h2>
    <Label
        >HAPI server URL (for testing):
        <ButtonGroup size="sm" class="w-full">
            <Input size="sm" bind:value={new_hapi_server} />
            <Button size="sm" on:click={() => check_and_add_hapi_server()}
                >Submit</Button>
        </ButtonGroup>
    </Label>
</div>
